diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
new file mode 100644
index 70d2570..6c6e88e
*** a/src/backend/access/transam/xlog.c
--- b/src/backend/access/transam/xlog.c
*************** typedef struct XLogCtlData
*** 577,583 ****
  	/* Protected by info_lck: */
  	XLogwrtRqst LogwrtRqst;
  	XLogRecPtr	RedoRecPtr;		/* a recent copy of Insert->RedoRecPtr */
- 	uint32		ckptXidEpoch;	/* nextXID & epoch of latest checkpoint */
  	TransactionId ckptXid;
  	XLogRecPtr	asyncXactLSN;	/* LSN of newest async commit/abort */
  	XLogRecPtr	replicationSlotMinLSN;	/* oldest LSN needed by any slot */
--- 577,582 ----
*************** BootStrapXLOG(void)
*** 5004,5017 ****
  	checkPoint.ThisTimeLineID = ThisTimeLineID;
  	checkPoint.PrevTimeLineID = ThisTimeLineID;
  	checkPoint.fullPageWrites = fullPageWrites;
! 	checkPoint.nextXidEpoch = 0;
! 	checkPoint.nextXid = FirstNormalTransactionId;
  	checkPoint.nextOid = FirstBootstrapObjectId;
! 	checkPoint.nextMulti = FirstMultiXactId;
  	checkPoint.nextMultiOffset = 0;
! 	checkPoint.oldestXid = FirstNormalTransactionId;
  	checkPoint.oldestXidDB = TemplateDbOid;
! 	checkPoint.oldestMulti = FirstMultiXactId;
  	checkPoint.oldestMultiDB = TemplateDbOid;
  	checkPoint.oldestCommitTsXid = InvalidTransactionId;
  	checkPoint.newestCommitTsXid = InvalidTransactionId;
--- 5003,5015 ----
  	checkPoint.ThisTimeLineID = ThisTimeLineID;
  	checkPoint.PrevTimeLineID = ThisTimeLineID;
  	checkPoint.fullPageWrites = fullPageWrites;
! 	checkPoint.nextXid = FirstNormalTransactionId + 1;
  	checkPoint.nextOid = FirstBootstrapObjectId;
! 	checkPoint.nextMulti = FirstMultiXactId + 1;
  	checkPoint.nextMultiOffset = 0;
! 	checkPoint.oldestXid = checkPoint.nextXid - 1;
  	checkPoint.oldestXidDB = TemplateDbOid;
! 	checkPoint.oldestMulti = checkPoint.nextMulti - 1;
  	checkPoint.oldestMultiDB = TemplateDbOid;
  	checkPoint.oldestCommitTsXid = InvalidTransactionId;
  	checkPoint.newestCommitTsXid = InvalidTransactionId;
*************** readRecoveryCommandFile(void)
*** 5245,5258 ****
  		else if (strcmp(item->name, "recovery_target_xid") == 0)
  		{
  			errno = 0;
! 			recoveryTargetXid = (TransactionId) strtoul(item->value, NULL, 0);
  			if (errno == EINVAL || errno == ERANGE)
  				ereport(FATAL,
  						(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
  				  errmsg("recovery_target_xid is not a valid number: \"%s\"",
  						 item->value)));
  			ereport(DEBUG2,
! 					(errmsg_internal("recovery_target_xid = %u",
  									 recoveryTargetXid)));
  			recoveryTarget = RECOVERY_TARGET_XID;
  		}
--- 5243,5256 ----
  		else if (strcmp(item->name, "recovery_target_xid") == 0)
  		{
  			errno = 0;
! 			recoveryTargetXid = (TransactionId) pg_strtouint64(item->value, NULL, 0);
  			if (errno == EINVAL || errno == ERANGE)
  				ereport(FATAL,
  						(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
  				  errmsg("recovery_target_xid is not a valid number: \"%s\"",
  						 item->value)));
  			ereport(DEBUG2,
! 					(errmsg_internal("recovery_target_xid = " XID_FMT,
  									 recoveryTargetXid)));
  			recoveryTarget = RECOVERY_TARGET_XID;
  		}
*************** recoveryStopsBefore(XLogReaderState *rec
*** 5729,5742 ****
  		if (isCommit)
  		{
  			ereport(LOG,
! 					(errmsg("recovery stopping before commit of transaction %u, time %s",
  							recoveryStopXid,
  							timestamptz_to_str(recoveryStopTime))));
  		}
  		else
  		{
  			ereport(LOG,
! 					(errmsg("recovery stopping before abort of transaction %u, time %s",
  							recoveryStopXid,
  							timestamptz_to_str(recoveryStopTime))));
  		}
--- 5727,5740 ----
  		if (isCommit)
  		{
  			ereport(LOG,
! 					(errmsg("recovery stopping before commit of transaction " XID_FMT ", time %s",
  							recoveryStopXid,
  							timestamptz_to_str(recoveryStopTime))));
  		}
  		else
  		{
  			ereport(LOG,
! 					(errmsg("recovery stopping before abort of transaction " XID_FMT ", time %s",
  							recoveryStopXid,
  							timestamptz_to_str(recoveryStopTime))));
  		}
*************** recoveryStopsAfter(XLogReaderState *reco
*** 5868,5874 ****
  				xact_info == XLOG_XACT_COMMIT_PREPARED)
  			{
  				ereport(LOG,
! 						(errmsg("recovery stopping after commit of transaction %u, time %s",
  								recoveryStopXid,
  								timestamptz_to_str(recoveryStopTime))));
  			}
--- 5866,5872 ----
  				xact_info == XLOG_XACT_COMMIT_PREPARED)
  			{
  				ereport(LOG,
! 						(errmsg("recovery stopping after commit of transaction " XID_FMT ", time %s",
  								recoveryStopXid,
  								timestamptz_to_str(recoveryStopTime))));
  			}
*************** recoveryStopsAfter(XLogReaderState *reco
*** 5876,5882 ****
  					 xact_info == XLOG_XACT_ABORT_PREPARED)
  			{
  				ereport(LOG,
! 						(errmsg("recovery stopping after abort of transaction %u, time %s",
  								recoveryStopXid,
  								timestamptz_to_str(recoveryStopTime))));
  			}
--- 5874,5880 ----
  					 xact_info == XLOG_XACT_ABORT_PREPARED)
  			{
  				ereport(LOG,
! 						(errmsg("recovery stopping after abort of transaction " XID_FMT ", time %s",
  								recoveryStopXid,
  								timestamptz_to_str(recoveryStopTime))));
  			}
*************** StartupXLOG(void)
*** 6311,6317 ****
  					(errmsg("entering standby mode")));
  		else if (recoveryTarget == RECOVERY_TARGET_XID)
  			ereport(LOG,
! 					(errmsg("starting point-in-time recovery to XID %u",
  							recoveryTargetXid)));
  		else if (recoveryTarget == RECOVERY_TARGET_TIME)
  			ereport(LOG,
--- 6309,6315 ----
  					(errmsg("entering standby mode")));
  		else if (recoveryTarget == RECOVERY_TARGET_XID)
  			ereport(LOG,
! 					(errmsg("starting point-in-time recovery to XID " XID_FMT,
  							recoveryTargetXid)));
  		else if (recoveryTarget == RECOVERY_TARGET_TIME)
  			ereport(LOG,
*************** StartupXLOG(void)
*** 6604,6625 ****
  				  (uint32) (checkPoint.redo >> 32), (uint32) checkPoint.redo,
  							 wasShutdown ? "TRUE" : "FALSE")));
  	ereport(DEBUG1,
! 			(errmsg_internal("next transaction ID: %u:%u; next OID: %u",
! 							 checkPoint.nextXidEpoch, checkPoint.nextXid,
! 							 checkPoint.nextOid)));
  	ereport(DEBUG1,
! 			(errmsg_internal("next MultiXactId: %u; next MultiXactOffset: %u",
! 						 checkPoint.nextMulti, checkPoint.nextMultiOffset)));
  	ereport(DEBUG1,
! 	   (errmsg_internal("oldest unfrozen transaction ID: %u, in database %u",
! 						checkPoint.oldestXid, checkPoint.oldestXidDB)));
  	ereport(DEBUG1,
! 			(errmsg_internal("oldest MultiXactId: %u, in database %u",
! 						 checkPoint.oldestMulti, checkPoint.oldestMultiDB)));
  	ereport(DEBUG1,
! 			(errmsg_internal("commit timestamp Xid oldest/newest: %u/%u",
! 							 checkPoint.oldestCommitTsXid,
! 							 checkPoint.newestCommitTsXid)));
  	if (!TransactionIdIsNormal(checkPoint.nextXid))
  		ereport(PANIC,
  				(errmsg("invalid next transaction ID")));
--- 6602,6623 ----
  				  (uint32) (checkPoint.redo >> 32), (uint32) checkPoint.redo,
  							 wasShutdown ? "TRUE" : "FALSE")));
  	ereport(DEBUG1,
! 			(errmsg_internal("next transaction ID: " XID_FMT " next OID: %u",
! 					checkPoint.nextXid,
! 					checkPoint.nextOid)));
  	ereport(DEBUG1,
! 			(errmsg_internal("next MultiXactId: " XID_FMT "; next MultiXactOffset: " INT64_FORMAT,
! 					checkPoint.nextMulti, checkPoint.nextMultiOffset)));
  	ereport(DEBUG1,
! 			(errmsg_internal("oldest unfrozen transaction ID: " XID_FMT ", in database %u",
! 					checkPoint.oldestXid, checkPoint.oldestXidDB)));
  	ereport(DEBUG1,
! 			(errmsg_internal("oldest MultiXactId: " XID_FMT ", in database %u",
! 					checkPoint.oldestMulti, checkPoint.oldestMultiDB)));
  	ereport(DEBUG1,
! 			(errmsg_internal("commit timestamp Xid oldest/newest: " XID_FMT "/" XID_FMT,
! 					checkPoint.oldestCommitTsXid,
! 					checkPoint.newestCommitTsXid)));
  	if (!TransactionIdIsNormal(checkPoint.nextXid))
  		ereport(PANIC,
  				(errmsg("invalid next transaction ID")));
*************** StartupXLOG(void)
*** 6634,6640 ****
  	SetMultiXactIdLimit(checkPoint.oldestMulti, checkPoint.oldestMultiDB, true);
  	SetCommitTsLimit(checkPoint.oldestCommitTsXid,
  					 checkPoint.newestCommitTsXid);
- 	XLogCtl->ckptXidEpoch = checkPoint.nextXidEpoch;
  	XLogCtl->ckptXid = checkPoint.nextXid;
  
  	/*
--- 6632,6637 ----
*************** StartupXLOG(void)
*** 7414,7420 ****
  		 */
  		if (recoveryTarget == RECOVERY_TARGET_XID)
  			snprintf(reason, sizeof(reason),
! 					 "%s transaction %u",
  					 recoveryStopAfter ? "after" : "before",
  					 recoveryStopXid);
  		else if (recoveryTarget == RECOVERY_TARGET_TIME)
--- 7411,7417 ----
  		 */
  		if (recoveryTarget == RECOVERY_TARGET_XID)
  			snprintf(reason, sizeof(reason),
! 					 "%s transaction " XID_FMT,
  					 recoveryStopAfter ? "after" : "before",
  					 recoveryStopXid);
  		else if (recoveryTarget == RECOVERY_TARGET_TIME)
*************** GetLastSegSwitchData(XLogRecPtr *lastSwi
*** 8280,8320 ****
  }
  
  /*
-  * GetNextXidAndEpoch - get the current nextXid value and associated epoch
-  *
-  * This is exported for use by code that would like to have 64-bit XIDs.
-  * We don't really support such things, but all XIDs within the system
-  * can be presumed "close to" the result, and thus the epoch associated
-  * with them can be determined.
-  */
- void
- GetNextXidAndEpoch(TransactionId *xid, uint32 *epoch)
- {
- 	uint32		ckptXidEpoch;
- 	TransactionId ckptXid;
- 	TransactionId nextXid;
- 
- 	/* Must read checkpoint info first, else have race condition */
- 	SpinLockAcquire(&XLogCtl->info_lck);
- 	ckptXidEpoch = XLogCtl->ckptXidEpoch;
- 	ckptXid = XLogCtl->ckptXid;
- 	SpinLockRelease(&XLogCtl->info_lck);
- 
- 	/* Now fetch current nextXid */
- 	nextXid = ReadNewTransactionId();
- 
- 	/*
- 	 * nextXid is certainly logically later than ckptXid.  So if it's
- 	 * numerically less, it must have wrapped into the next epoch.
- 	 */
- 	if (nextXid < ckptXid)
- 		ckptXidEpoch++;
- 
- 	*xid = nextXid;
- 	*epoch = ckptXidEpoch;
- }
- 
- /*
   * This must be called ONCE during postmaster or standalone-backend shutdown
   */
  void
--- 8277,8282 ----
*************** CreateCheckPoint(int flags)
*** 8733,8743 ****
  	checkPoint.newestCommitTsXid = ShmemVariableCache->newestCommitTsXid;
  	LWLockRelease(CommitTsLock);
  
- 	/* Increase XID epoch if we've wrapped around since last checkpoint */
- 	checkPoint.nextXidEpoch = ControlFile->checkPointCopy.nextXidEpoch;
- 	if (checkPoint.nextXid < ControlFile->checkPointCopy.nextXid)
- 		checkPoint.nextXidEpoch++;
- 
  	LWLockAcquire(OidGenLock, LW_SHARED);
  	checkPoint.nextOid = ShmemVariableCache->nextOid;
  	if (!shutdown)
--- 8695,8700 ----
*************** CreateCheckPoint(int flags)
*** 8880,8888 ****
  	UpdateControlFile();
  	LWLockRelease(ControlFileLock);
  
! 	/* Update shared-memory copy of checkpoint XID/epoch */
  	SpinLockAcquire(&XLogCtl->info_lck);
- 	XLogCtl->ckptXidEpoch = checkPoint.nextXidEpoch;
  	XLogCtl->ckptXid = checkPoint.nextXid;
  	SpinLockRelease(&XLogCtl->info_lck);
  
--- 8837,8844 ----
  	UpdateControlFile();
  	LWLockRelease(ControlFileLock);
  
! 	/* Update shared-memory copy of checkpoint XID/base */
  	SpinLockAcquire(&XLogCtl->info_lck);
  	XLogCtl->ckptXid = checkPoint.nextXid;
  	SpinLockRelease(&XLogCtl->info_lck);
  
*************** xlog_redo(XLogReaderState *record)
*** 9707,9718 ****
  		}
  
  		/* ControlFile->checkPointCopy always tracks the latest ckpt XID */
- 		ControlFile->checkPointCopy.nextXidEpoch = checkPoint.nextXidEpoch;
  		ControlFile->checkPointCopy.nextXid = checkPoint.nextXid;
  
! 		/* Update shared-memory copy of checkpoint XID/epoch */
  		SpinLockAcquire(&XLogCtl->info_lck);
- 		XLogCtl->ckptXidEpoch = checkPoint.nextXidEpoch;
  		XLogCtl->ckptXid = checkPoint.nextXid;
  		SpinLockRelease(&XLogCtl->info_lck);
  
--- 9663,9672 ----
  		}
  
  		/* ControlFile->checkPointCopy always tracks the latest ckpt XID */
  		ControlFile->checkPointCopy.nextXid = checkPoint.nextXid;
  
! 		/* Update shared-memory copy of checkpoint XID/base */
  		SpinLockAcquire(&XLogCtl->info_lck);
  		XLogCtl->ckptXid = checkPoint.nextXid;
  		SpinLockRelease(&XLogCtl->info_lck);
  
*************** xlog_redo(XLogReaderState *record)
*** 9757,9768 ****
  			SetTransactionIdLimit(checkPoint.oldestXid,
  								  checkPoint.oldestXidDB);
  		/* ControlFile->checkPointCopy always tracks the latest ckpt XID */
- 		ControlFile->checkPointCopy.nextXidEpoch = checkPoint.nextXidEpoch;
  		ControlFile->checkPointCopy.nextXid = checkPoint.nextXid;
  
! 		/* Update shared-memory copy of checkpoint XID/epoch */
  		SpinLockAcquire(&XLogCtl->info_lck);
- 		XLogCtl->ckptXidEpoch = checkPoint.nextXidEpoch;
  		XLogCtl->ckptXid = checkPoint.nextXid;
  		SpinLockRelease(&XLogCtl->info_lck);
  
--- 9711,9720 ----
  			SetTransactionIdLimit(checkPoint.oldestXid,
  								  checkPoint.oldestXidDB);
  		/* ControlFile->checkPointCopy always tracks the latest ckpt XID */
  		ControlFile->checkPointCopy.nextXid = checkPoint.nextXid;
  
! 		/* Update shared-memory copy of checkpoint XID/base */
  		SpinLockAcquire(&XLogCtl->info_lck);
  		XLogCtl->ckptXid = checkPoint.nextXid;
  		SpinLockRelease(&XLogCtl->info_lck);
  
diff --git a/src/backend/bootstrap/bootstrap.c b/src/backend/bootstrap/bootstrap.c
new file mode 100644
index d2708cb..9fd692b
*** a/src/backend/bootstrap/bootstrap.c
--- b/src/backend/bootstrap/bootstrap.c
*************** static const struct typinfo TypInfo[] = 
*** 127,133 ****
  	F_OIDIN, F_OIDOUT},
  	{"tid", TIDOID, 0, 6, false, 's', 'p', InvalidOid,
  	F_TIDIN, F_TIDOUT},
! 	{"xid", XIDOID, 0, 4, true, 'i', 'p', InvalidOid,
  	F_XIDIN, F_XIDOUT},
  	{"cid", CIDOID, 0, 4, true, 'i', 'p', InvalidOid,
  	F_CIDIN, F_CIDOUT},
--- 127,133 ----
  	F_OIDIN, F_OIDOUT},
  	{"tid", TIDOID, 0, 6, false, 's', 'p', InvalidOid,
  	F_TIDIN, F_TIDOUT},
! 	{"xid", XIDOID, 0, 8, FLOAT8PASSBYVAL, 'd', 'p', InvalidOid,
  	F_XIDIN, F_XIDOUT},
  	{"cid", CIDOID, 0, 4, true, 'i', 'p', InvalidOid,
  	F_CIDIN, F_CIDOUT},
diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
new file mode 100644
index 4e5b79e..6589378
*** a/src/backend/catalog/heap.c
--- b/src/backend/catalog/heap.c
*************** static FormData_pg_attribute a2 = {
*** 156,162 ****
  static FormData_pg_attribute a3 = {
  	0, {"xmin"}, XIDOID, 0, sizeof(TransactionId),
  	MinTransactionIdAttributeNumber, 0, -1, -1,
! 	true, 'p', 'i', true, false, '\0', false, true, 0
  };
  
  static FormData_pg_attribute a4 = {
--- 156,162 ----
  static FormData_pg_attribute a3 = {
  	0, {"xmin"}, XIDOID, 0, sizeof(TransactionId),
  	MinTransactionIdAttributeNumber, 0, -1, -1,
! 	FLOAT8PASSBYVAL, 'p', 'd', true, false, '\0', false, true, 0
  };
  
  static FormData_pg_attribute a4 = {
*************** static FormData_pg_attribute a4 = {
*** 168,174 ****
  static FormData_pg_attribute a5 = {
  	0, {"xmax"}, XIDOID, 0, sizeof(TransactionId),
  	MaxTransactionIdAttributeNumber, 0, -1, -1,
! 	true, 'p', 'i', true, false, '\0', false, true, 0
  };
  
  static FormData_pg_attribute a6 = {
--- 168,174 ----
  static FormData_pg_attribute a5 = {
  	0, {"xmax"}, XIDOID, 0, sizeof(TransactionId),
  	MaxTransactionIdAttributeNumber, 0, -1, -1,
! 	FLOAT8PASSBYVAL, 'p', 'd', true, false, '\0', false, true, 0
  };
  
  static FormData_pg_attribute a6 = {
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
new file mode 100644
index 7a6da1e..fe33748
*** a/src/backend/catalog/index.c
--- b/src/backend/catalog/index.c
*************** IndexBuildHeapRangeScan(Relation heapRel
*** 2409,2415 ****
  					 * before commit there.  Give a warning if neither case
  					 * applies.
  					 */
! 					xwait = HeapTupleHeaderGetXmin(heapTuple->t_data);
  					if (!TransactionIdIsCurrentTransactionId(xwait))
  					{
  						if (!is_system_catalog)
--- 2409,2415 ----
  					 * before commit there.  Give a warning if neither case
  					 * applies.
  					 */
! 					xwait = HeapTupleGetXmin(heapTuple);
  					if (!TransactionIdIsCurrentTransactionId(xwait))
  					{
  						if (!is_system_catalog)
*************** IndexBuildHeapRangeScan(Relation heapRel
*** 2457,2463 ****
  						break;
  					}
  
! 					xwait = HeapTupleHeaderGetUpdateXid(heapTuple->t_data);
  					if (!TransactionIdIsCurrentTransactionId(xwait))
  					{
  						if (!is_system_catalog)
--- 2457,2463 ----
  						break;
  					}
  
! 					xwait = HeapTupleGetUpdateXidAny(heapTuple);
  					if (!TransactionIdIsCurrentTransactionId(xwait))
  					{
  						if (!is_system_catalog)
diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
new file mode 100644
index ecdd895..7f805c9
*** a/src/backend/commands/analyze.c
--- b/src/backend/commands/analyze.c
*************** acquire_sample_rows(Relation onerel, int
*** 1068,1073 ****
--- 1068,1074 ----
  			targtuple.t_tableOid = RelationGetRelid(onerel);
  			targtuple.t_data = (HeapTupleHeader) PageGetItem(targpage, itemid);
  			targtuple.t_len = ItemIdGetLength(itemid);
+ 			HeapTupleCopyBaseFromPage(&targtuple, targpage);
  
  			switch (HeapTupleSatisfiesVacuum(&targtuple,
  											 OldestXmin,
*************** acquire_sample_rows(Relation onerel, int
*** 1105,1111 ****
  					 * has to adjust the numbers we send to the stats
  					 * collector to make this come out right.)
  					 */
! 					if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(targtuple.t_data)))
  					{
  						sample_it = true;
  						liverows += 1;
--- 1106,1112 ----
  					 * has to adjust the numbers we send to the stats
  					 * collector to make this come out right.)
  					 */
! 					if (TransactionIdIsCurrentTransactionId(HeapTupleGetXmin(&targtuple)))
  					{
  						sample_it = true;
  						liverows += 1;
*************** acquire_sample_rows(Relation onerel, int
*** 1125,1131 ****
  					 * right.  (Note: this works out properly when the row was
  					 * both inserted and deleted in our xact.)
  					 */
! 					if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetUpdateXid(targtuple.t_data)))
  						deadrows += 1;
  					else
  						liverows += 1;
--- 1126,1132 ----
  					 * right.  (Note: this works out properly when the row was
  					 * both inserted and deleted in our xact.)
  					 */
! 					if (TransactionIdIsCurrentTransactionId(HeapTupleGetUpdateXidAny(&targtuple)))
  						deadrows += 1;
  					else
  						liverows += 1;
diff --git a/src/backend/commands/async.c b/src/backend/commands/async.c
new file mode 100644
index 87b215d..bf9c96e
*** a/src/backend/commands/async.c
--- b/src/backend/commands/async.c
*************** typedef struct QueuePosition
*** 199,211 ****
  
  /* choose logically smaller QueuePosition */
  #define QUEUE_POS_MIN(x,y) \
! 	(asyncQueuePagePrecedes((x).page, (y).page) ? (x) : \
  	 (x).page != (y).page ? (y) : \
  	 (x).offset < (y).offset ? (x) : (y))
  
  /* choose logically larger QueuePosition */
  #define QUEUE_POS_MAX(x,y) \
! 	(asyncQueuePagePrecedes((x).page, (y).page) ? (y) : \
  	 (x).page != (y).page ? (x) : \
  	 (x).offset > (y).offset ? (x) : (y))
  
--- 199,211 ----
  
  /* choose logically smaller QueuePosition */
  #define QUEUE_POS_MIN(x,y) \
! 	(((x).page < (y).page) ? (x) : \
  	 (x).page != (y).page ? (y) : \
  	 (x).offset < (y).offset ? (x) : (y))
  
  /* choose logically larger QueuePosition */
  #define QUEUE_POS_MAX(x,y) \
! 	(((x).page < (y).page) ? (y) : \
  	 (x).page != (y).page ? (x) : \
  	 (x).offset > (y).offset ? (x) : (y))
  
*************** static bool backendHasSentNotifications 
*** 368,374 ****
  bool		Trace_notify = false;
  
  /* local function prototypes */
- static bool asyncQueuePagePrecedes(int p, int q);
  static void queue_listen(ListenActionKind action, const char *channel);
  static void Async_UnlistenOnExit(int code, Datum arg);
  static void Exec_ListenPreCommit(void);
--- 368,373 ----
*************** static bool AsyncExistsPendingNotify(con
*** 394,422 ****
  static void ClearPendingActionsAndNotifies(void);
  
  /*
-  * We will work on the page range of 0..QUEUE_MAX_PAGE.
-  */
- static bool
- asyncQueuePagePrecedes(int p, int q)
- {
- 	int			diff;
- 
- 	/*
- 	 * We have to compare modulo (QUEUE_MAX_PAGE+1)/2.  Both inputs should be
- 	 * in the range 0..QUEUE_MAX_PAGE.
- 	 */
- 	Assert(p >= 0 && p <= QUEUE_MAX_PAGE);
- 	Assert(q >= 0 && q <= QUEUE_MAX_PAGE);
- 
- 	diff = p - q;
- 	if (diff >= ((QUEUE_MAX_PAGE + 1) / 2))
- 		diff -= QUEUE_MAX_PAGE + 1;
- 	else if (diff < -((QUEUE_MAX_PAGE + 1) / 2))
- 		diff += QUEUE_MAX_PAGE + 1;
- 	return diff < 0;
- }
- 
- /*
   * Report space needed for our shared memory area
   */
  Size
--- 393,398 ----
*************** AsyncShmemInit(void)
*** 475,481 ****
  	/*
  	 * Set up SLRU management of the pg_notify data.
  	 */
- 	AsyncCtl->PagePrecedes = asyncQueuePagePrecedes;
  	SimpleLruInit(AsyncCtl, "async", NUM_ASYNC_BUFFERS, 0,
  				  AsyncCtlLock, "pg_notify", LWTRANCHE_ASYNC_BUFFERS);
  	/* Override default assumption that writes should be fsync'd */
--- 451,456 ----
*************** asyncQueueIsFull(void)
*** 1234,1240 ****
  		nexthead = 0;			/* wrap around */
  	boundary = QUEUE_POS_PAGE(QUEUE_TAIL);
  	boundary -= boundary % SLRU_PAGES_PER_SEGMENT;
! 	return asyncQueuePagePrecedes(nexthead, boundary);
  }
  
  /*
--- 1209,1215 ----
  		nexthead = 0;			/* wrap around */
  	boundary = QUEUE_POS_PAGE(QUEUE_TAIL);
  	boundary -= boundary % SLRU_PAGES_PER_SEGMENT;
! 	return (nexthead < boundary);
  }
  
  /*
*************** asyncQueueAdvanceTail(void)
*** 2012,2018 ****
  	 */
  	newtailpage = QUEUE_POS_PAGE(min);
  	boundary = newtailpage - (newtailpage % SLRU_PAGES_PER_SEGMENT);
! 	if (asyncQueuePagePrecedes(oldtailpage, boundary))
  	{
  		/*
  		 * SimpleLruTruncate() will ask for AsyncCtlLock but will also release
--- 1987,1993 ----
  	 */
  	newtailpage = QUEUE_POS_PAGE(min);
  	boundary = newtailpage - (newtailpage % SLRU_PAGES_PER_SEGMENT);
! 	if (oldtailpage < boundary)
  	{
  		/*
  		 * SimpleLruTruncate() will ask for AsyncCtlLock but will also release
diff --git a/src/backend/commands/cluster.c b/src/backend/commands/cluster.c
new file mode 100644
index ef1abf3..2704fc4
*** a/src/backend/commands/cluster.c
--- b/src/backend/commands/cluster.c
*************** copy_heap_data(Oid OIDNewHeap, Oid OIDOl
*** 991,997 ****
  				 * case we had better copy it.
  				 */
  				if (!is_system_catalog &&
! 					!TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(tuple->t_data)))
  					elog(WARNING, "concurrent insert in progress within table \"%s\"",
  						 RelationGetRelationName(OldHeap));
  				/* treat as live */
--- 991,997 ----
  				 * case we had better copy it.
  				 */
  				if (!is_system_catalog &&
! 					!TransactionIdIsCurrentTransactionId(HeapTupleGetXmin(tuple)))
  					elog(WARNING, "concurrent insert in progress within table \"%s\"",
  						 RelationGetRelationName(OldHeap));
  				/* treat as live */
*************** copy_heap_data(Oid OIDNewHeap, Oid OIDOl
*** 1003,1009 ****
  				 * Similar situation to INSERT_IN_PROGRESS case.
  				 */
  				if (!is_system_catalog &&
! 					!TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetUpdateXid(tuple->t_data)))
  					elog(WARNING, "concurrent delete in progress within table \"%s\"",
  						 RelationGetRelationName(OldHeap));
  				/* treat as recently dead */
--- 1003,1009 ----
  				 * Similar situation to INSERT_IN_PROGRESS case.
  				 */
  				if (!is_system_catalog &&
! 					!TransactionIdIsCurrentTransactionId(HeapTupleGetUpdateXidAny(tuple)))
  					elog(WARNING, "concurrent delete in progress within table \"%s\"",
  						 RelationGetRelationName(OldHeap));
  				/* treat as recently dead */
diff --git a/src/backend/commands/copy.c b/src/backend/commands/copy.c
new file mode 100644
index ae79a2f..ba58eb5
*** a/src/backend/commands/copy.c
--- b/src/backend/commands/copy.c
*************** CopyFrom(CopyState cstate)
*** 2533,2538 ****
--- 2533,2539 ----
  		 * t_tableOid before evaluating them.
  		 */
  		tuple->t_tableOid = RelationGetRelid(resultRelInfo->ri_RelationDesc);
+ 		HeapTupleSetZeroBase(tuple);
  
  		/* Triggers and stuff need to be invoked in query context. */
  		MemoryContextSwitchTo(oldcontext);
diff --git a/src/backend/commands/sequence.c b/src/backend/commands/sequence.c
new file mode 100644
index 902ae41..147357f
*** a/src/backend/commands/sequence.c
--- b/src/backend/commands/sequence.c
*************** fill_seq_with_data(Relation rel, HeapTup
*** 338,343 ****
--- 338,344 ----
  	page = BufferGetPage(buf);
  
  	PageInit(page, BufferGetPageSize(buf), sizeof(HeapPageSpecialData));
+ 	HeapPageGetSpecial(page)->pd_xid_base = RecentXmin - FirstNormalTransactionId;
  	HeapPageGetSpecial(page)->pd_magic = SEQ_PAGE_MAGIC;
  
  	/* Now insert sequence tuple */
*************** fill_seq_with_data(Relation rel, HeapTup
*** 351,360 ****
  	 * because if the current transaction aborts, no other xact will ever
  	 * examine the sequence tuple anyway.
  	 */
! 	HeapTupleHeaderSetXmin(tuple->t_data, FrozenTransactionId);
  	HeapTupleHeaderSetXminFrozen(tuple->t_data);
  	HeapTupleHeaderSetCmin(tuple->t_data, FirstCommandId);
! 	HeapTupleHeaderSetXmax(tuple->t_data, InvalidTransactionId);
  	tuple->t_data->t_infomask |= HEAP_XMAX_INVALID;
  	ItemPointerSet(&tuple->t_data->t_ctid, 0, FirstOffsetNumber);
  
--- 352,361 ----
  	 * because if the current transaction aborts, no other xact will ever
  	 * examine the sequence tuple anyway.
  	 */
! 	HeapTupleSetXmin(tuple, FrozenTransactionId);
  	HeapTupleHeaderSetXminFrozen(tuple->t_data);
  	HeapTupleHeaderSetCmin(tuple->t_data, FirstCommandId);
! 	HeapTupleSetXmax(tuple, InvalidTransactionId);
  	tuple->t_data->t_infomask |= HEAP_XMAX_INVALID;
  	ItemPointerSet(&tuple->t_data->t_ctid, 0, FirstOffsetNumber);
  
*************** read_seq_tuple(Relation rel, Buffer *buf
*** 1176,1181 ****
--- 1177,1183 ----
  	/* Note we currently only bother to set these two fields of *seqdatatuple */
  	seqdatatuple->t_data = (HeapTupleHeader) PageGetItem(page, lp);
  	seqdatatuple->t_len = ItemIdGetLength(lp);
+ 	HeapTupleCopyBaseFromPage(seqdatatuple, page);
  
  	/*
  	 * Previous releases of Postgres neglected to prevent SELECT FOR UPDATE on
*************** read_seq_tuple(Relation rel, Buffer *buf
*** 1186,1194 ****
  	 * this again if the update gets lost.
  	 */
  	Assert(!(seqdatatuple->t_data->t_infomask & HEAP_XMAX_IS_MULTI));
! 	if (HeapTupleHeaderGetRawXmax(seqdatatuple->t_data) != InvalidTransactionId)
  	{
! 		HeapTupleHeaderSetXmax(seqdatatuple->t_data, InvalidTransactionId);
  		seqdatatuple->t_data->t_infomask &= ~HEAP_XMAX_COMMITTED;
  		seqdatatuple->t_data->t_infomask |= HEAP_XMAX_INVALID;
  		MarkBufferDirtyHint(*buf, true);
--- 1188,1196 ----
  	 * this again if the update gets lost.
  	 */
  	Assert(!(seqdatatuple->t_data->t_infomask & HEAP_XMAX_IS_MULTI));
! 	if (HeapTupleGetRawXmax(seqdatatuple) != InvalidTransactionId)
  	{
! 		HeapTupleSetXmax(seqdatatuple, InvalidTransactionId);
  		seqdatatuple->t_data->t_infomask &= ~HEAP_XMAX_COMMITTED;
  		seqdatatuple->t_data->t_infomask |= HEAP_XMAX_INVALID;
  		MarkBufferDirtyHint(*buf, true);
*************** seq_redo(XLogReaderState *record)
*** 1888,1893 ****
--- 1890,1896 ----
  	localpage = (Page) palloc(BufferGetPageSize(buffer));
  
  	PageInit(localpage, BufferGetPageSize(buffer), sizeof(HeapPageSpecialData));
+ 	HeapPageGetSpecial(page)->pd_xid_base = RecentXmin - FirstNormalTransactionId;
  	HeapPageGetSpecial(page)->pd_magic = SEQ_PAGE_MAGIC;
  
  	item = (char *) xlrec + sizeof(xl_seq_rec);
diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
new file mode 100644
index 0271788..521713d
*** a/src/backend/commands/trigger.c
--- b/src/backend/commands/trigger.c
*************** ltrmark:;
*** 3023,3028 ****
--- 3023,3029 ----
  		tuple.t_len = ItemIdGetLength(lp);
  		tuple.t_self = *tid;
  		tuple.t_tableOid = RelationGetRelid(relation);
+ 		HeapTupleCopyBaseFromPage(&tuple, page);
  
  		LockBuffer(buffer, BUFFER_LOCK_UNLOCK);
  	}
